﻿package com.bowl{

	// bit101 import
	import com.bit101.components.HUISlider;
	import com.bit101.components.Window;
	import com.bit101.components.PushButton;
	import com.bit101.components.ComboBox;
	
	// pv3 import
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.cameras.Camera3D;

	import org.papervision3d.objects.primitives.Cylinder;
	import org.papervision3d.objects.primitives.Cone;
	
	import org.papervision3d.objects.primitives.Plane;
	import org.papervision3d.objects.DisplayObject3D;

	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.special.LineMaterial;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.special.LineMaterial;
	import org.papervision3d.materials.MovieMaterial;

	import org.papervision3d.core.math.Number3D;
	import org.papervision3d.core.math.Plane3D;

	import org.papervision3d.lights.PointLight3D;
	
	import org.papervision3d.core.geom.Lines3D;
	import org.papervision3d.core.geom.renderables.Line3D;
	import org.papervision3d.core.geom.renderables.Vertex3D;

	import org.papervision3d.core.render.data.RenderHitData;
	import org.papervision3d.core.proto.MaterialObject3D;
	import org.papervision3d.core.geom.Vertices3D;
	import org.papervision3d.core.geom.renderables.Vertex3D;
	
	import org.papervision3d.events.InteractiveScene3DEvent;
	
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.StageDisplayState;
	import flash.display.StageQuality;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	
	import flash.display.GradientType;
	import flash.geom.Matrix;

	// tweens
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.ColorShortcuts;
	import caurina.transitions.Equations;

	// flash import
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;

	import flash.geom.Point;
		
	// uncontrol import
	import com.uncontrol.BoilerPlate;
	import com.uncontrol.Utils;

	import net.pluginmedia.pv3d.Circle3D;


	public class Bowl extends BoilerPlate{
		private var scene		:Scene3D; 
		private var renderer	:BasicRenderEngine;
		private var viewport	:Viewport3D;
		private var camera 		:Camera3D;
		private var cursor3D	:DisplayObject3D;
		private var base		:DisplayObject3D;
		
		private var cameraTarget:DisplayObject3D;

		private var cameraData:Object;

		private var isOrbiting:Boolean = false;
		private var previousMouseX:Number;
		private var previousMouseY:Number;
		
		private var isKeyPressed:Boolean = false;
		private var TWO_PI:Number = Math.PI * 2;
		
		private var totalSegments:int = 21;
		private var totalDepth:int = 20;
		
		private var counter:int = 0;

		private var page:Plane;
		private var pageWire:Plane;
		private	var point:Point;

		private var number3DArray:Array;
		private var transformAPointArray:Array;
		private var transformBPointArray:Array;
		private var transformCPointArray:Array;
		
		private var number3D:Number3D;
		//
		private var planeToDragOnNonX:Plane3D;
		private var planeToDragOnNonY:Plane3D;
		private var planeToDragOnNonZ:Plane3D;
		private var currentPlane:Plane;
		private var light:PointLight3D;
		
		private var interactivePlaneA:Plane;
		private var interactivePlaneB:Plane;
		private var interactivePlaneC:Plane;
		private var interactivePlaneD:Plane;
		private var interactivePlaneE:Plane;
		private var interactivePlaneF:Plane;
		private var interactivePlaneG:Plane;
		private var interactivePlaneH:Plane;

		private var deltaBA:Number3D;
		private var deltaBE:Number3D;
		private var deltaBC:Number3D;
		private var deltaBG:Number3D;

		private var deltaDF:Number3D;
		private var deltaDH:Number3D;

		
		public function Bowl():void {
		

			setScope('Bowl');
			
			point = new Point(0, 0);
			number3D = new Number3D();
			transformAPointArray = new Array();
			transformBPointArray = new Array();
			transformCPointArray = new Array();

			cameraData = new Object();
			cameraData.pitch = 47;
			cameraData.yaw = 288;

		}

		public function init():void{
			tracer('init');

			// stage.displayState 	= StageDisplayState.FULL_SCREEN;
			stage.scaleMode 		= StageScaleMode.NO_SCALE;
			stage.quality 			= StageQuality.LOW;
			
			this.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDownHandler, false,0,true);
			this.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMoveHandler, false,0,true);
			this.addEventListener(MouseEvent.MOUSE_UP, onMouseUpHandler, false,0,true);
			this.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheelHandler, false, 0, true);
			
			createWorld();
			// createGridMarks();
			createShapes();
			createSliders();
			

			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDownHandler, false,0,true);
			stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUpHandler, false,0,true);

			this.addEventListener(Event.ENTER_FRAME,update);

			isKeyPressed = true;
			onMouseDownHandler();
			onMouseMoveHandler();
			onMouseUpHandler();
			// isKeyPressed = false;
			
		}
		
		/**
		 * create world sets the defaults for all papervision info
		 * base is the displayObject3D that everything is applied to similiar to this.context
		 * baseOffset is used for and world transformations 
		 */
		public function createWorld():void{
						
			viewport 		= new Viewport3D(stage.stageWidth, stage.stageHeight, false, true,true);
			viewport.containerSprite.name = 'paperBaseView';											// name required for hit with construction
			viewport.interactive = true;

			var square:Sprite = new Sprite();
			/*
			square.graphics.beginFill(0xFFFFFF);
			square.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			square.graphics.endFill();
			*/
			var matrix:Matrix = new Matrix();
			matrix.createGradientBox(stage.stageWidth, stage.stageHeight, 0, 0, 0);
				
			square.graphics.beginGradientFill("radial", [0xFFFFFF,0xCCCCCC], [100, 200], [0, 0xFF], matrix, "pad", "RGB", 0);
				
			square.graphics.moveTo(0, 0);
			square.graphics.lineTo(stage.stageWidth, 0);
			square.graphics.lineTo(stage.stageWidth, stage.stageHeight);
			square.graphics.lineTo(0, stage.stageHeight);
			square.graphics.lineTo(0, 0);
			square.graphics.endFill();
			
			
			this.addChild(square);
			
			square.addChild(viewport);
			
			renderer 		= new BasicRenderEngine();
			scene 			= new Scene3D();

			base 			= new DisplayObject3D();
			base.extra 		= new Object();				
			scene.addChild(base);

			cameraTarget 	= new DisplayObject3D();
			base.addChild(cameraTarget);
			
			camera 			= new Camera3D();
			camera.extra 	= new Object();

			camera.target	= cameraTarget;
			
		}
		
		/**
		 * create XYZ marks for easy viewing
		*/
		public function createGridMarks():void{
			var grid3D = new DisplayObject3D();
			var clutMat = new WireframeMaterial();
			var cursor:Plane;

			clutMat = new WireframeMaterial(0xFF0000,1);
			clutMat.doubleSided = true;
			cursor = new Plane(clutMat, 1, 500, 1, 1 );
			grid3D.addChild(cursor);
			
			clutMat = new WireframeMaterial(0x00FF00,1);
			clutMat.doubleSided = true;
			cursor = new Plane(clutMat, 1, 500, 1, 1 );
			cursor.rotationX = 90;
			grid3D.addChild(cursor);
			
			clutMat = new WireframeMaterial(0x0000FF,1);
			clutMat.doubleSided = true;

			cursor = new Plane(clutMat, 1, 500, 1, 1 );
			cursor.rotationX = 90;
			cursor.rotationY = 90;

			grid3D.addChild(cursor);
			base.addChild(grid3D);
		}
		
		/**
		 * create shapes based on primitives
		 */
		public function createShapes() {
			
			var i:uint;
			var j:uint;
			var seed:int;
			var line:Line3D;
			
			var detail:int = 3;

			var lightGreenCircleMaterial:MovieMaterial = createCircleMaterial(0x000000,.5);
			var lightGreenSquareMaterial:MovieMaterial = createSquareMaterial(0x000000,.5);
			var darkGreenCircleMaterial:MovieMaterial = createCircleMaterial(0x000000, .5);
			
			var redSquareMaterial:MovieMaterial = createSquareMaterial(0x000000,.5);
			
			var blueSquareMaterial:MovieMaterial = createSquareMaterial(0x000000,.5);
			var blueCircleMaterial:MovieMaterial = createCircleMaterial(0x000000,.5);
			
			var greySquareMaterial:MovieMaterial = createSquareMaterial(0x000000,.25);
			greySquareMaterial.interactive = false;
			
			
			/*		
			var bitmapData : BitmapData = new PaperMaterial(0, 0);  
			var bitmapMaterial : BitmapMaterial = new BitmapMaterial(bitmapData);  
			bitmapMaterial.doubleSided = true;  
			*/

			var wireMaterial:WireframeMaterial = new WireframeMaterial(0x000000,.125);
			wireMaterial.doubleSided = true;
			
			var colorMaterial:ColorMaterial = new ColorMaterial(0xFF6600, .5);
			// colorMaterial.interactive = true;
			colorMaterial.doubleSided = true;
			
			
			
			var matrix:Matrix = new Matrix();
			matrix.createGradientBox(stage.stageWidth, stage.stageHeight, 0, 0, 0);
			var square:Sprite = new Sprite();
			square.graphics.clear();
			// square.graphics.beginGradientFill(TypeError,	Color,alpha,ratios,
			square.graphics.beginGradientFill("radial", [0x000000,0x000000], [25, 0], [0x00, 0xFF], matrix, "pad", "RGB", 0);
			square.graphics.moveTo(0, 0);
			square.graphics.lineTo(stage.stageWidth, 0);
			square.graphics.lineTo(stage.stageWidth, stage.stageHeight);
			square.graphics.lineTo(0, stage.stageHeight);
			square.graphics.lineTo(0, 0);
			square.graphics.endFill();
			
			var gradientMaterial:MovieMaterial = new MovieMaterial(square, true, true); 
			// gradientMaterial.interactive = true;
			gradientMaterial.doubleSided = true;	
			
			
			
			page = new Plane(gradientMaterial, 400, 400, totalDepth - 1, totalSegments - 1);			
			base.addChild(page);
			
			pageWire = new Plane(wireMaterial, 400, 400, totalDepth - 1, totalSegments - 1);			
			base.addChild(pageWire);
			
			number3DArray  = new Array();
			seed = 0;
			for (j = 0; j < totalDepth; j++) {
				for (i = 0; i < totalSegments; i++) {
					number3DArray[seed] = new Number3D();
					seed++;
				}
			}

			

			interactivePlaneA = new Plane(lightGreenCircleMaterial, 50, 50, detail, detail);
			interactivePlaneA.z = -200;
			interactivePlaneA.y = 0;
			interactivePlaneA.rotationY = 90;				
			base.addChild(interactivePlaneA);
			interactivePlaneA.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);

			interactivePlaneB = new Plane(darkGreenCircleMaterial, 50, 50,detail, detail);
			interactivePlaneB.rotationY = 90;				
			base.addChild(interactivePlaneB);
			interactivePlaneB.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);

			interactivePlaneE = new Plane(lightGreenSquareMaterial, 100, 25, detail, detail);
			interactivePlaneE.z = 200;
			interactivePlaneE.y = 0;
			interactivePlaneE.rotationY = 90;				
			base.addChild(interactivePlaneE);
			interactivePlaneE.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler, false, 0, true);
			
			deltaBA = new Number3D(0, 0, 0);
			deltaBE = new Number3D(0, 0, 0);
			deltaBC = new Number3D(0, 0, 0);
			deltaBG = new Number3D(0, 0, 0);

			interactivePlaneC = new Plane(redSquareMaterial, 25, 100, detail, detail);
			interactivePlaneC.y = -125;
			base.addChild(interactivePlaneC);
			interactivePlaneC.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);
			
			interactivePlaneG = new Plane(redSquareMaterial, 25, 100, detail, detail);
			interactivePlaneG.y = 125;
			base.addChild(interactivePlaneG);
			interactivePlaneG.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);
			
			interactivePlaneD = new Plane(blueCircleMaterial, 50, 50, detail, detail);
			interactivePlaneD.rotationX = 90;
			interactivePlaneD.x = 0;
			interactivePlaneD.z = 0;
			base.addChild(interactivePlaneD);
			interactivePlaneD.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);
			
			interactivePlaneF = new Plane(blueSquareMaterial, 100, 25, detail, detail);
			interactivePlaneF.rotationX = 90;
			interactivePlaneF.x = -100;
			interactivePlaneF.z = 0;
			base.addChild(interactivePlaneF);
			interactivePlaneF.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);

			interactivePlaneH = new Plane(blueSquareMaterial, 100, 25, detail, detail);
			interactivePlaneH.rotationX = 90;
			interactivePlaneH.x = 100;
			interactivePlaneH.z = 0;
			base.addChild(interactivePlaneH);
			interactivePlaneH.addEventListener(InteractiveScene3DEvent.OBJECT_PRESS, objectPressHandler,false,0,true);

			deltaDF = new Number3D(0, 0, 0);
			deltaDH = new Number3D(0, 0, 0);
			
			
			planeToDragOnNonX = new Plane3D(new Number3D(1, 0, 0), new Number3D(0,0,0));
			planeToDragOnNonY = new Plane3D(new Number3D(0, 1, 0), new Number3D(0,0,0));
			planeToDragOnNonZ = new Plane3D(new Number3D(0, 0, 1), new Number3D(0,0,0));
			
			
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler,false,0,true);

			// plane.lookAt(camera);
			
		}
		
		
		private function createCircleMaterial(color:Number = 0x000000,alpha:Number=.5):MovieMaterial {
			var circle:Sprite = new Sprite();
			circle.graphics.clear();
			// circle.graphics.lineStyle(10,color,alpha)
			circle.graphics.beginFill(color,alpha);
			circle.graphics.drawEllipse(0, 0, 100, 100);
			circle.graphics.endFill();
			
			var material:MovieMaterial = new MovieMaterial(circle, true, true); 
			material.interactive = true;
			material.doubleSided = true;	
			return material;
		}
		
		private function createSquareMaterial(color:Number = 0x000000,alpha:Number=.5):MovieMaterial {
			var circle:Sprite = new Sprite();
			circle.graphics.clear();
			// circle.graphics.lineStyle(10,color,alpha)
			circle.graphics.beginFill(color,alpha);
			circle.graphics.drawRect(0, 0, 100, 100);
			circle.graphics.endFill();
			
			var material:MovieMaterial = new MovieMaterial(circle, true, true); 
			material.interactive = true;
			material.doubleSided = true;	
			return material;
		}
		
		private function objectPressHandler(event:InteractiveScene3DEvent):void{
			currentPlane = event.displayObject3D as Plane;
			
			if (currentPlane == interactivePlaneB) {
				deltaBA.x = interactivePlaneB.x - interactivePlaneA.x;
				deltaBA.y = interactivePlaneB.y - interactivePlaneA.y;
				deltaBA.z = interactivePlaneB.z - interactivePlaneA.z;
				
				deltaBE.x = interactivePlaneB.x - interactivePlaneE.x;
				deltaBE.y = interactivePlaneB.y - interactivePlaneE.y;
				deltaBE.z = interactivePlaneB.z - interactivePlaneE.z;
				
				deltaBC.x = interactivePlaneB.x - interactivePlaneC.x;
				deltaBC.y = interactivePlaneB.y - interactivePlaneC.y;
				deltaBC.z = interactivePlaneB.z - interactivePlaneC.z;
				
				deltaBG.x = interactivePlaneB.x - interactivePlaneG.x;
				deltaBG.y = interactivePlaneB.y - interactivePlaneG.y;
				deltaBG.z = interactivePlaneB.z - interactivePlaneG.z;
			} else if (currentPlane == interactivePlaneD) {
				deltaDF.x = interactivePlaneD.x - interactivePlaneF.x;
				deltaDF.y = interactivePlaneD.y - interactivePlaneF.y;
				deltaDF.z = interactivePlaneD.z - interactivePlaneF.z;
				
				deltaDH.x = interactivePlaneD.x - interactivePlaneH.x;
				deltaDH.y = interactivePlaneD.y - interactivePlaneH.y;
				deltaDH.z = interactivePlaneD.z - interactivePlaneH.z;
				
			}
			isKeyPressed = false;
		}
		
		private function mouseUpHandler(event:MouseEvent):void {
			currentPlane = null;
			
			resetBounds(interactivePlaneA);
			resetBounds(interactivePlaneB);
			resetBounds(interactivePlaneC);
			resetBounds(interactivePlaneD);
			resetBounds(interactivePlaneE);
			
			isKeyPressed = true;
		}
		
		private function resetBounds(plane:Plane=null):void {
			var bounds:Number = 1000;
			plane.x = Math.max( -bounds, Math.min(bounds, plane.x) );
			plane.y = Math.max( -bounds, Math.min(bounds, plane.y) );
			plane.z = Math.max( -bounds, Math.min(bounds, plane.z) );

		}
		/**
		 * returns point after rotation
		 * @param	oldPoint
		 * @param	anchorPoint
		 * @param	degrees
		 * @return
		 */
		public function getRotatedPoint(oldPoint:Point, anchorPoint:Point, degrees:Number=0):Point {
			var relativePoint:Point = oldPoint.subtract(anchorPoint);
			var angleExisting:Number = Math.atan2(relativePoint.y, relativePoint.x);
			var angleToBeRotated = TWO_PI * (	degrees  / 360); // 15°
			var distance = Point.distance(anchorPoint, oldPoint);
			return Point.polar(distance, angleToBeRotated+angleExisting).add(anchorPoint);
		}

		/**
		 * loop via Event.ENTER_FRAME
		 * @param	e
		 */
		public function update(e:Event):void {
			
			var planeToDragOn:Plane3D;
			
			if (currentPlane == interactivePlaneB) {
				interactivePlaneA.x = interactivePlaneB.x - deltaBA.x;
				interactivePlaneA.y = interactivePlaneB.y - deltaBA.y;
				interactivePlaneA.z = interactivePlaneB.z - deltaBA.z;
				
				interactivePlaneE.x = interactivePlaneB.x - deltaBE.x;
				interactivePlaneE.y = interactivePlaneB.y - deltaBE.y;
				interactivePlaneE.z = interactivePlaneB.z - deltaBE.z;
				
				interactivePlaneC.x = interactivePlaneB.x - deltaBC.x;
				interactivePlaneC.y = interactivePlaneB.y - deltaBC.y;
				interactivePlaneC.z = interactivePlaneB.z - deltaBC.z;
				
				interactivePlaneG.x = interactivePlaneB.x - deltaBG.x;
				interactivePlaneG.y = interactivePlaneB.y - deltaBG.y;
				interactivePlaneG.z = interactivePlaneB.z - deltaBG.z;
			} else if (currentPlane == interactivePlaneD) {
				interactivePlaneF.x = interactivePlaneD.x - deltaDF.x;
				interactivePlaneF.y = interactivePlaneD.y - deltaDF.y;
				interactivePlaneF.z = interactivePlaneD.z - deltaDF.z;
				
				interactivePlaneH.x = interactivePlaneD.x - deltaDH.x;
				interactivePlaneH.y = interactivePlaneD.y - deltaDH.y;
				interactivePlaneH.z = interactivePlaneD.z - deltaDH.z;
				
			}
			if (currentPlane) {
			
				switch(currentPlane) {
					case interactivePlaneA:
					case interactivePlaneB:
					case interactivePlaneE:
						planeToDragOn = planeToDragOnNonX;
						break;
					case interactivePlaneC:
					case interactivePlaneG:
						planeToDragOn = planeToDragOnNonZ;
						break;
					case interactivePlaneD:
					case interactivePlaneF:
					case interactivePlaneH:
						planeToDragOn = planeToDragOnNonY;
						break;
				}
				var camNum3D:Number3D = new Number3D(camera.x, camera.y, camera.z);
				var ray:Number3D = camera.unproject(viewport.containerSprite.mouseX, viewport.containerSprite.mouseY);
				ray = Number3D.add(ray, camNum3D);
				var cameraVertex3D:Vertex3D = new Vertex3D(camera.x, camera.y, camera.z);
				var rayVertex3D:Vertex3D = new Vertex3D(ray.x, ray.y, ray.z);
				var intersectPoint:Vertex3D = planeToDragOn.getIntersectionLine(cameraVertex3D, rayVertex3D);
				currentPlane.x = intersectPoint.x;
				currentPlane.y = intersectPoint.y;
				currentPlane.z = intersectPoint.z;
				
				interactivePlaneC.z = interactivePlaneB.z;
				interactivePlaneC.x = interactivePlaneB.x;
				// interactivePlaneD.x = 0;

				interactivePlaneE.y = interactivePlaneB.y;
				
				interactivePlaneF.z = interactivePlaneD.z;
				interactivePlaneH.z = interactivePlaneD.z;

				interactivePlaneG.x = interactivePlaneC.x;
 				interactivePlaneG.z = interactivePlaneC.z;
								
				resetBounds(interactivePlaneA);
				resetBounds(interactivePlaneB);
				resetBounds(interactivePlaneC);
				resetBounds(interactivePlaneD);
				resetBounds(interactivePlaneE);
				resetBounds(interactivePlaneF);
				resetBounds(interactivePlaneG);
				resetBounds(interactivePlaneH);
			}
			
		
			
			
			
			archIncrementSlider.value = interactivePlaneB.distanceTo(interactivePlaneE) * .025;
			
			swirlRadiusSlider.value = interactivePlaneF.distanceTo(interactivePlaneD) * .025;
			swirlSpeedSlider.value = interactivePlaneH.distanceTo(interactivePlaneD) * .5 + 1;

			curveSpreadSlider.value = interactivePlaneG.distanceTo(interactivePlaneB) * .025;

			camera.lookAt(base);
			
			var i:uint;
			var j:uint;
			
			var seed:int;
			var geometrySeed:int;
			
			var matrixPoint1:Point;
			var anchorPoint1:Point = new Point(interactivePlaneA.z, interactivePlaneA.y);
			var rotationPoint1:Point = new Point(interactivePlaneB.z, interactivePlaneB.y);

			var matrixPoint2:Point;
			var anchorPoint2:Point = new Point(interactivePlaneC.x, interactivePlaneC.y);
			var rotationPoint2:Point = new Point(0, 0);
			
			var matrixPoint3:Point;
			var anchorPoint3:Point = new Point(interactivePlaneD.x, interactivePlaneD.z);
			var rotationPoint3:Point = new Point(0, 0);

			var matrixPoint4:Point;
			var anchorPoint4:Point = new Point(interactivePlaneB.z, interactivePlaneB.y);
			var rotationPoint4:Point = new Point(0, 0);
			var anglePoint4:Point = new Point(interactivePlaneE.z, interactivePlaneE.y);

			var relativePoint:Point = anglePoint4.subtract(anchorPoint4);
			var angleExisting:Number = Math.atan2(relativePoint.y, relativePoint.x) * 180/Math.PI;
			
			var angleToBeRotated:Number;
			var distance:Number;

			var matrixPointArray:Array = new Array();
			var rotationPointArray:Array = new Array();
			
			// save all the positions along the arc
			
			seed = 0;
			for (j = 0; j < totalDepth; j++) {
				for (i = 0; i < totalSegments; i++) {
					// ------------------------------------------------
					// create arch with y and z movement
					rotationPoint1.x = interactivePlaneB.z;
					rotationPoint1.y = interactivePlaneB.y;
					
					matrixPoint1 = getRotatedPoint(rotationPoint1, anchorPoint1,j*archIncrementSlider.value);
					
					number3DArray[seed].x = 0;
					number3DArray[seed].y = matrixPoint1.y; 
					number3DArray[seed].z = matrixPoint1.x;
					
					
					// ------------------------------------------------
					// create curve with x and y movement
					rotationPoint2.x = 0;
					rotationPoint2.y = matrixPoint1.y;
					
					matrixPoint2 = getRotatedPoint(rotationPoint2,anchorPoint2,(curveSpreadSlider.value*i)-curveSpreadSlider.value*totalSegments*.5 + curveSpreadSlider.value*.5);
					
					number3DArray[seed].x = matrixPoint2.x;
					number3DArray[seed].y = matrixPoint2.y; 
					number3DArray[seed].z = matrixPoint1.x;
					
					
					// ------------------------------------------------
					// create swirl with x and z movement
					rotationPoint3.x = matrixPoint2.x;
					rotationPoint3.y = matrixPoint1.x;
					
					matrixPoint3 = getRotatedPoint(rotationPoint3, anchorPoint3, j*swirlLengthSlider.value);

					number3DArray[seed].x = matrixPoint3.x;
					number3DArray[seed].y = matrixPoint2.y; 
					number3DArray[seed].z = matrixPoint3.y;
					
					/*
					// ------------------------------------------------
					// re-rotate along B
					rotationPoint4.x = matrixPoint3.y;
					rotationPoint4.y = matrixPoint2.y; 
					
					
					matrixPoint4 = getRotatedPoint(rotationPoint4, anchorPoint4, angleExisting+90);
					
					number3DArray[seed].x = matrixPoint3.x;
					number3DArray[seed].y = matrixPoint4.y; 
					number3DArray[seed].z = matrixPoint4.x;
					*/
					seed++;
				}
				
				
			}
			
			
			swirlLengthSlider.value =  Math.sin(TWO_PI * (counter / (361-swirlSpeedSlider.value))) * swirlRadiusSlider.value;
			
			counter++;
			// draw
			seed = 0;
			geometrySeed = 0;
			for (j = 0; j < totalDepth; j++) {
				for (i = 0; i < totalSegments; i++) {
					geometrySeed = i+j*totalSegments;
					page.geometry.vertices[geometrySeed].x = number3DArray[seed].x;	
					page.geometry.vertices[geometrySeed].y = number3DArray[seed].y;	
					page.geometry.vertices[geometrySeed].z = number3DArray[seed].z;
					
					
					pageWire.geometry.vertices[geometrySeed].x = number3DArray[seed].x;	
					pageWire.geometry.vertices[geometrySeed].y = number3DArray[seed].y;	
					pageWire.geometry.vertices[geometrySeed].z = number3DArray[seed].z;
					seed++;
				}
			}
			
			// draw
			// base.rotationY += .5;
			renderer.renderScene(scene,camera, viewport);			// standard loop requred to render papervision
		}
		
		private function onKeyUpHandler(e:KeyboardEvent = null):void {
			// trace('onKeyUpHandler',e.keyCode);
		}

		private function onKeyDownHandler(event:KeyboardEvent  = null):void {
			// trace('onKeyDownHandler',e.keyCode);
		}

		
		private function onMouseWheelHandler(event:MouseEvent=null):void {
			camera.moveForward(30 * event.delta);
		}

		private function onMouseDownHandler(event:MouseEvent = null):void	{
			if (!isKeyPressed) return;
			isOrbiting = true;
			previousMouseX = mouseX;
			previousMouseY = mouseY;
			onMouseMoveHandler();
		}

		private function onMouseUpHandler(event:MouseEvent=null):void {
			isOrbiting = false;
		}

		private function onMouseMoveHandler(event:MouseEvent=null):void	{
			if (!isKeyPressed) return;
			var differenceX:Number = mouseX - previousMouseX;
			var differenceY:Number = mouseY - previousMouseY;

			if (isOrbiting) {
				cameraData.pitch += differenceY;
				cameraData.yaw += differenceX;
		
				cameraData.pitch %= 360;
				cameraData.yaw %= 360;
				
				cameraData.pitch = cameraData.pitch < 90 ? cameraData.pitch : 89.9999;
				cameraData.pitch = cameraData.pitch > 0 ? cameraData.pitch : 0.0001;

				previousMouseX = mouseX;
				previousMouseY = mouseY;

				camera.orbit(cameraData.pitch, cameraData.yaw);
			}
		}
		
		/**
		 * Trigger when component window is minimized/maximized
		 * @param	e
		 */
		private function onComponentWindowChangeHandler(e:Event = null):void {
			for (var i:int = 0; i < sliderHUISliderArray.length; i++ ) {
				sliderHUISliderArray[i].visible = !e.target.minimized;
			}
		}
		
		private var archIncrementSlider:HUISlider;

		private var curveSpreadSlider:HUISlider;

		private var swirlLengthSlider:HUISlider;
		private var swirlSpeedSlider:HUISlider;
		private var swirlRadiusSlider:HUISlider;
		
		private var sliderWindow:Window;
		private var sliderHUISliderArray:Array;

		private var hideComps:PushButton;
		private var toggleView:PushButton;
		private var randomizeSliders:PushButton;

		private function onViewChangeHandler(e:Event=null):void {
			if (toggleView.label == 'SHOW WIRE') {
				page.visible = false;
				pageWire.visible = true;
				toggleView.label = 'SHOW BOTH';
			} else if (toggleView.label == 'SHOW BOTH') {
				page.visible = true;
				pageWire.visible = true;
				toggleView.label = 'SHOW PLANE';
			} else if (toggleView.label == 'SHOW PLANE') {
				page.visible = true;
				pageWire.visible = false;
				toggleView.label = 'SHOW WIRE';
			}
		}
		
		private function setRandomControlPositions(e:Event = null):void {
			
			// var newMaterial:MovieMaterial = createSquareMaterial(Math.random()*0xFFFFFF,.25);
			// newMaterial.interactive = false;
			
			// var wireMaterial:WireframeMaterial = new WireframeMaterial(Math.random()*0xFFFFFF,.125);
			// wireMaterial.doubleSided = true;
			
			
			var matrix:Matrix = new Matrix();
			matrix.createGradientBox(stage.stageWidth, stage.stageHeight, 0, 0, 0);
				
			
			
			
			/*
			var square:Sprite = new Sprite();
			square.graphics.clear();
			square.graphics.beginGradientFill("radial", [0x000000,0x000000], [100, 0], [0, 0xFF], matrix, "pad", "RGB", 0);
			square.graphics.moveTo(0, 0);
			square.graphics.lineTo(stage.stageWidth, 0);
			square.graphics.lineTo(stage.stageWidth, stage.stageHeight);
			square.graphics.lineTo(0, stage.stageHeight);
			square.graphics.lineTo(0, 0);
			square.graphics.endFill();
			
			var material:MovieMaterial = new MovieMaterial(square, true, true); 
			material.interactive = true;
			material.doubleSided = true;	
			
			page.material = material;
			*/

			
			var delayInc:Number = 0;// .25;
			var delay:Number = 0;// -.25;
			var time:Number = 5.0;
			Tweener.addTween(interactivePlaneA, { y:randomNumber(), z:randomNumber(), delay:delay += delayInc, time:time, transition:'easeInOutQuad' } );
			Tweener.addTween(interactivePlaneE, { z:randomNumber(), delay:delay += delayInc, time:time, transition:'easeInOutQuad' } );
			
			Tweener.addTween(interactivePlaneC, { y:randomNumber(), delay:delay += delayInc, time:time, transition:'easeInOutQuad' } );
			Tweener.addTween(interactivePlaneG, { y:-randomNumber(), delay:delay += delayInc, time:time, transition:'easeInOutQuad' } );

			var randZ:Number = randomNumber();
			Tweener.addTween(interactivePlaneD, { z:randZ, delay:delay, time:time, transition:'easeInOutQuad' } );
			Tweener.addTween(interactivePlaneF, { z:randZ, delay:delay, time:time, transition:'easeInOutQuad' } );
			Tweener.addTween(interactivePlaneH, { z:randZ, delay:delay, time:time, transition:'easeInOutQuad' } );
		}
		
		private function randomNumber(radius:Number = 1000):Number {
			return (int(Math.random() * radius/2));
		}
		
		private function onComboBoxhandler(e:Event = null):void {
			trace('onComboBoxhandler', e.target.selectedIndex);
			interactivePlaneA.visible = false;
			interactivePlaneB.visible = false;
			interactivePlaneC.visible = false;
			interactivePlaneD.visible = false;
			interactivePlaneE.visible = false;
			interactivePlaneF.visible = false;
			interactivePlaneG.visible = false;
			interactivePlaneH.visible = false;
			
			switch(e.target.selectedIndex) {
				case 0:
					interactivePlaneA.visible = true;
					interactivePlaneB.visible = true;
					interactivePlaneC.visible = true;
					interactivePlaneD.visible = true;
					interactivePlaneE.visible = true;
					interactivePlaneF.visible = true;
					interactivePlaneG.visible = true;
					interactivePlaneH.visible = true;
					break;
				case 1:
					
					break;
				case 2:
					interactivePlaneA.visible = true;
					interactivePlaneB.visible = true;
					interactivePlaneE.visible = true;
					break;
				case 3:
					interactivePlaneC.visible = true;
					interactivePlaneG.visible = true;
					break;
				case 4:
					interactivePlaneD.visible = true;
					interactivePlaneF.visible = true;
					interactivePlaneH.visible = true;
					break;
			}
		}
		
		private function onControlViewChangeHandler(e:Event = null):void {
			interactivePlaneA.visible = false;
			interactivePlaneB.visible = false;
			interactivePlaneC.visible = false;
			interactivePlaneD.visible = false;
			interactivePlaneE.visible = false;
			interactivePlaneF.visible = false;
			interactivePlaneG.visible = false;
			interactivePlaneH.visible = false;
			
			if (hideComps.label == 'SHOW ALL CONTROLS') {
				interactivePlaneA.visible = true;
				interactivePlaneB.visible = true;
				interactivePlaneC.visible = true;
				interactivePlaneD.visible = true;
				interactivePlaneE.visible = true;
				interactivePlaneF.visible = true;
				interactivePlaneG.visible = true;
				interactivePlaneH.visible = true;
				
				hideComps.label = 'HIDE ALL CONTROLS';
			} else if (hideComps.label == 'HIDE ALL CONTROLS') {
				
				hideComps.label = 'SHOW ARCH CONTROLS';
			} else if (hideComps.label == 'SHOW ARCH CONTROLS') {
				interactivePlaneA.visible = true;
				interactivePlaneB.visible = true;
				interactivePlaneE.visible = true;

				hideComps.label = 'SHOW CURVE CONTROLS';
			} else if (hideComps.label == 'SHOW CURVE CONTROLS') {
				interactivePlaneC.visible = true;
				interactivePlaneG.visible = true;
				
				hideComps.label = 'SHOW SWIRL CONTROLS';
			} else if (hideComps.label == 'SHOW SWIRL CONTROLS') {
				interactivePlaneD.visible = true;
				interactivePlaneF.visible = true;
				interactivePlaneH.visible = true;
				
				hideComps.label = 'SHOW ALL CONTROLS';
			}
		}
				
		/**
		 * create sliders, will need to be replaced with data
		 */
		private function createSliders():void {
			var i:uint;
			var yOffset:Number = 30;
			var leftMargin:Number = 8;
			var sliderWidth:Number = 360;
			
			hideComps = new PushButton(this, 10, 10, 'HIDE ALL CONTROLS', onControlViewChangeHandler);
			hideComps.width = 120;
			onControlViewChangeHandler();
			
			
			toggleView = new PushButton(this, 130+10, 10, 'SHOW PLANE', onViewChangeHandler);
			toggleView.width = 120;
			onViewChangeHandler();
			hideComps.label = 'SHOW ALL CONTROLS';
			
			randomizeSliders = new PushButton(this, 260+10, 10, 'RANDOMIZE', setRandomControlPositions);
			randomizeSliders.width = 120;
			
			// hack for now, will remove in the future
			sliderWindow = new Window(this, 20, 20, 'sliders');
			sliderWindow.width = 380;
			sliderWindow.hasMinimizeButton = true;
			sliderWindow.shadow = false;
			sliderWindow.minimized = true;
			sliderWindow.addEventListener(Event.RESIZE, onComponentWindowChangeHandler, false, 0, true);
			sliderWindow.color = 0xFFFFFF;
			sliderWindow.visible = false;
			
			sliderHUISliderArray = new Array();

			archIncrementSlider = new HUISlider(sliderWindow,0,0,'archIncrementSlider');
			archIncrementSlider.minimum = 0;
			archIncrementSlider.maximum = 20;
			archIncrementSlider.value = 4;
			archIncrementSlider.tick = .001;
			archIncrementSlider.visible = false;
			// sliderHUISliderArray.push(archIncrementSlider);
			
			curveSpreadSlider = new HUISlider(sliderWindow,0,0,'curveSpreadSlider');
			curveSpreadSlider.minimum = 0;
			curveSpreadSlider.maximum = 360/(totalSegments-1);
			curveSpreadSlider.value = 15;
			
			// totalSegments
			
			curveSpreadSlider.tick = .001;
			curveSpreadSlider.visible = false;
			// sliderHUISliderArray.push(curveSpreadSlider);
			
			swirlLengthSlider = new HUISlider(sliderWindow,0,0,'swirlLengthSlider');
			swirlLengthSlider.minimum = -15;
			swirlLengthSlider.maximum = 15;
			swirlLengthSlider.value = 0;
			swirlLengthSlider.tick = .001;
			swirlLengthSlider.visible = false;
			// sliderHUISliderArray.push(swirlLengthSlider);

			swirlSpeedSlider = new HUISlider(sliderWindow,0,0,'swirlSpeedSlider');
			swirlSpeedSlider.minimum = 1;
			swirlSpeedSlider.maximum = 360;
			swirlSpeedSlider.value = 60;
			swirlSpeedSlider.tick = 1;
			swirlSpeedSlider.visible = false;
			// sliderHUISliderArray.push(swirlSpeedSlider);

			swirlRadiusSlider = new HUISlider(sliderWindow,0,0,'swirlRadiusSlider');
			swirlRadiusSlider.minimum = 0;
			swirlRadiusSlider.maximum = 10;
			swirlRadiusSlider.value = .125;
			swirlRadiusSlider.tick = .001;
			swirlRadiusSlider.visible = false;
			// sliderHUISliderArray.push(swirlRadiusSlider);

			for (i = 0; i < sliderHUISliderArray.length; i++ ) {
				var huiSlider:HUISlider = sliderHUISliderArray[i];
				huiSlider.width = sliderWidth;
				huiSlider.visible = false;
				huiSlider.x = 20;
				huiSlider.y = yOffset + i*20;
			}
			
			sliderWindow.height = yOffset+sliderHUISliderArray.length*20 + 40;

		}
	}
}